/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "terminal.pmh"
#include "platform/dlCore.cc"

using namespace fe;

static sp<Master> gs_master;
static sp<Terminal> gs_terminal;

extern "C"
{

FE_DL_EXPORT int fe_terminal_execute(
		int a_outputSize,char* a_output,const char* a_input)
{
//	printf("::fe_terminal_execute \"%s\"\n",a_input);

	if(gs_master.isNull())
	{
		gs_master=new Master();
		gs_master->registry()->manage("fexTerminalDL");
	}
	if(gs_master.isValid() && gs_terminal.isNull())
	{
		gs_terminal=gs_master->registry()->create("*.Terminal");
	}
	if(gs_terminal.isValid())
	{
		String result=gs_terminal->execute(a_input);
		strncpy(a_output,result.c_str(),a_outputSize);
		return 1;
	}

	return 0;
}

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
	list.append(new String("fexMetaDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master>)
{
	Library *pLibrary = new Library();

	pLibrary->add<Terminal>("Component.Terminal.fe");

	pLibrary->add<TerminalDraw>("DrawI.TerminalDraw.fe");

	return pLibrary;
}

FE_DL_EXPORT void InitializeLibrary(sp<Library> spLibrary)
{
}

}
