/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __viewer__PerspectiveViewer_h__
#define __viewer__PerspectiveViewer_h__

namespace fe
{

/**	Perspective viewer

	@copydoc PerspectiveViewer_info
	*/
class FE_DL_EXPORT PerspectiveViewer :
	public Initialize<PerspectiveViewer>,
	virtual public ViewerI,
	virtual public HandlerI,
	virtual public BindI
{
	public:
				PerspectiveViewer(void);
virtual			~PerspectiveViewer(void);
		void	initialize(void);

				//* As ViewerI
virtual	void	bind(sp<WindowI> spWindowI);
virtual Real	frameRate(void) const;

				//* As HandlerI
virtual	void	handle(Record& record);
virtual	void	bind(sp<SignalerI> spSignalerI,
						sp<Layout> spLayout);

	private:
		sp<WindowI>						m_spWindowI;
		PathAccessor<SpatialTransform>	m_paPerspMatrix;
		AsSignal						m_asSignal;
		AsWindata						m_asWindata;
		sp<ViewI>						m_view;

		Real			m_frameMS;
		Real			m_frameRate;
		Real			m_frameTotal;
		U32				m_frameCount;
		SystemTicker	m_ticker;
};

} /* namespace */

#endif /* __viewer__PerspectiveViewer_h__ */

